function [ net, info ] = MatConvNet_ReTrain( netToUse, imagesUrl, prev, new )
    
    if(nargin==0)
        imagesUrl = '/home/CNN_files';

        % Definisco le classi su cui addestare il classficatore
        % Mettere prima la classe "positiva"
        %categories = {'oro', 'none'};

        % googlenet, resnet_152
        netToUse = 'alexnet'; 

        prev = 4096;
        new = 3;
    end

%% CARICA RETE NON DAG
    
    switch netToUse
        case 'alexnet'
            % Definisco il nome del modello
            netName = 'imagenet-caffe-alex.mat';
        case 'vgg_verydeep'
            % Definisco il nome del modello
            netName = 'imagenet-vgg-verydeep-19.mat';
        case 'vgg_f'
            % Definisco il nome del modello
            netName = 'imagenet-vgg-f.mat';
        case 'vgg_m'
            % Definisco il nome del modello
            netName = 'imagenet-vgg-m.mat';
        case 'vgg_s'
            % Definisco il nome del modello
            netName = 'imagenet-vgg-s.mat';
        otherwise
            error('nome della rete sconosciuto');
    end

    
    net = load(netName);
    net = vl_simplenn_tidy(net);
    
    %% SOSTITUISCO GLI ULTIMI LIVELLI
    net.layers = net.layers(1:end-2);
    net.layers{end+1} = struct('type', 'conv', ...
    'weights', {{0.05*randn(1,1,prev,new, 'single'), zeros(1,new,'single')}}, ...
    'learningRate', [0.05, 0.05], ...
    'stride', [1 1], ...
    'pad', [0 0 0 0]) ;
    net.layers{end+1} = struct('type', 'softmaxloss') ;
    
    %% FREEZE DEI LAYER
    for i=1:numel(net.layers(1:end-2))
        net.layers{i}.learningRate = [0,0];
    end
    
    %% CARICO IMDS
    imdb = mioImageFolderToImdb(imagesUrl, ''); % lascia il nome vuoto per evitare salvataggio
    
    %% ADDESTRO MODELLO
    gpus = 1;% [], 1
    [net, info] = cnn_train(net, imdb, @getbatch, 'batchSize', 128, 'gpus', gpus, 'continue', false);

end

