function [ imdb ] = mioImageFolderToImdb(path, name)
%MIOIMAGEFOLDERTOIMDB Summary of this function goes here
%   Detailed explanation goes here
%name = 'CNN_files';
%path = '/home/CNN_files';

classes = dir(path) ;
classes = {classes([classes.isdir]).name} ;
classes(ismember(classes,{'.','..'})) = [] ;

num_images = zeros(1,numel(classes));
for i=1:numel(classes)
    num_images(1,i)=numel(dir(strcat(path,'/',classes{1,i})))-2;
end

min_num_images = min(num_images);

im = cell(numel(classes), min_num_images);
labels = cell(numel(classes), min_num_images);

for i = 1:numel(classes)
    image_dir = dir(fullfile(path,classes{1,i},'*.bmp'));
    image_dir = {image_dir.name};
    for j = 1:min_num_images      
      [p,cmap] = imread(strcat(path,'/',classes{1,i},'/',image_dir{1,j}));
      if isempty(cmap)
        im{i,j} = im2single(p) ;
      else
        im{i,j} = im2single(ind2gray(p,cmap)) ;
      end
      im{i,j}=cat(3,im{i,j},im{i,j},im{i,j});
      labels{i,j} = i ;
    end
end

sets = ones(numel(classes), min_num_images) ;
sets(:,end-uint16(min_num_images/5):end) = 2 ;
sets(:,end-uint16(min_num_images/10):end)    = 3 ;

imdb.meta.sets        = {'train', 'val', 'test'};
imdb.meta.classes     = classes;

imdb.images.data      = cat(4, im{:});
imdb.images.labels    = cat(2, labels{:});
imdb.images.set       = sets(:)';
imdb.images.data_mean = mean(imdb.images.data,4);

if(not(strcmp(name, '')))
    save(strcat(name,'.mat'), '-struct', 'imdb') ;
end


end

