function [ stack ] = dicom2imageStackGPU(DCMName,gpu)
dicomImm = dicomread(DCMName);
dicomInf = dicominfo(DCMName);
dI = dicomInf.PerFrameFunctionalGroupsSequence;
dI = struct2table(dI);
clear dicomInf;
numFrames = size(dicomImm,4);
dicomImm = gpuArray(dicomImm);
stack = zeros(uint16(single(size(dicomImm,1))/2),uint16(single(size(dicomImm,2))/2),size(dicomImm,4),'uint8','gpuArray');
w = waitbar(0,'Apertura immagine...');
for fr=1:numFrames
 %% Preprocessing immagine
    waitbar(fr/numFrames);
    imm = dicomImm(:,:,1,fr);
    WW = dI{1,fr}.FrameVOILUTSequence.Item_1.WindowWidth(1);
    WC =dI{1,fr}.FrameVOILUTSequence.Item_1.WindowCenter(1);
    imm = adjustImm(imm, WW, WC, 0, 255); 
    imm = imm(1:2:end,1:2:end);   
    stack(:,:,fr) = imm;   
    stack = uint8(stack);
end
close(w);
wait(gpu);
end