function rp = get2Dlesions(imst)
%Dimensioni dello stack di immagini
immbinStack = getBinarizedStackfromImST(imst);
dim = size(immbinStack);
ID = 1;
w = waitbar(0,'Individuazione lesioni...');
%% Identificazione delle aree mediante regionprops
for i = 1:size(immbinStack,3)
    stats = regionprops(immbinStack(:,:,i), 'PixelIdxList', 'FilledImage','Area','Centroid','BoundingBox');
    avgGray = zeros(size(stats,1));
    waitbar((i)/size(immbinStack,3));
    for ii=1:size(stats,1)
        mask = false(dim);
        pixlist = stats(ii).PixelIdxList;
        mask(pixlist) = true;        
        [X Y] = find(bwperim(immbinStack(:,:,i)&mask,8));
        avgGray = mean(imst(find(mask)));
        feats(ii) = calcolaFeatures(stats(ii).FilledImage,avgGray,stats(ii).Centroid,[X Y], stats(ii).BoundingBox);
        % SALVO GLI ESTREMI ED EFFETTUO IL CLIPPING
        xs = feats(ii).BoundingBox(2); xf = feats(ii).BoundingBox(2)+feats(ii).BoundingBox(4);
        ys = feats(ii).BoundingBox(1); yf = feats(ii).BoundingBox(1)+feats(ii).BoundingBox(3);
        xs = floor(xs); xf = floor(xf);
        ys = floor(ys); yf = floor(yf);
        if(xs < 0)
            xs = 0;
        end
        if(ys < 0)
            ys = 0;
        end
        if(xf > size(immbinStack(:,:,i),1))
            xf = size(immbinStack(:,:,i),1);
        end
        if(yf > size(immbinStack(:,:,i),2))
            yf = size(immbinStack(:,:,i),2);
        end
        % OTTENGO L'IMMAGINE CROPPATA
        imcropped =imst(xs:xf,ys:yf);
        %CALCOLO LA GLCM
        GLCM = graycomatrix(imcropped,'Offset',[2 0;0 2]);
        %CALCOLO LE FEATURES DI HARALICK
        stats4(ii) = GLCM_Features4(GLCM,1);
        
        feats(ii).Slice = i;       
        feats(ii).Name = strcat('Lesion_',int2str(i),'_',int2str(ii));
        feats(ii).ID = ID;
        ID = ID+1;
        
    end
    %Concateno in modo da unificare i risultati
    if i == 1
        featsFin = feats;
        stats4Fin = stats4;
    else
        featsFin = [featsFin feats];
        stats4Fin = [stats4Fin stats4];
    end
    clear feats stats4
end
featsFin = struct2table(featsFin);
stats4Fin = struct2table(stats4Fin);
rp = [featsFin stats4Fin];
rp = table2struct(rp);
close(w);
end

function [ out ] = calcolaFeatures( J, avgGray, Centroid,perimPixels,BoundingBox )

stats = regionprops('table', J, 'Centroid', 'Area', 'Perimeter', 'MajorAxisLength', 'MinorAxisLength', 'Eccentricity', 'Solidity', 'ConvexImage', 'Centroid','BoundingBox');
convexImageStats = regionprops('table', stats.ConvexImage{1,1},'Perimeter');

%OUTPUT--------------------------------------------------------------------
%numero di pixel all'interno della regione:
out.area                = stats.Area(1);
%somma delle distanze fra ciascuna coppia di pixel adiacenti attorno al
%bordo della regione
out.perimeter           = stats.Perimeter(1);
%4*pi*(A/P^2)
out.circularity         = 4*pi*out.area/out.perimeter^2;
%il rapporto tra asse maggiore e asse minore
out.aspectRatio         = stats.MajorAxisLength(1)/stats.MinorAxisLength(1);
%eccentricit� dell'ellisse: rapporto tra la distanza tra i due fuochi
%dell'ellisse e la lunghezza dell'asse maggiore.
out.ellipseEccentricity = stats.Eccentricity(1);
%proporzione dei pixel che appartengono alla convex hull che sono anche
%nella regione
out.solidity            = stats.Solidity(1);
%rapporto tra il perimetro della convex hull e quello della ROI
out.convexity           = convexImageStats.Perimeter(1)/out.perimeter(1);
out.avgGray = avgGray;
out.mask = J;
out.centroid = Centroid;
out.perimPixels = perimPixels;
out.BoundingBox = BoundingBox;
%Numero di slice, che verr aggiornato in seguito
out.Slice = 0;
out.Lesion = false;
out.LesionType = 'none';
out.Name = '';
out.ID = 0;
end

