function rp = get2DlesionsOpti(imst)
%Dimensioni dello stack di immagini
w = waitbar(0,'Preprocessing delle immagini...');
immbinStack = getBinarizedStackfromImSTrev1(imst);
waitbar(0.33,w,'Individuazione lesioni...');
dim = size(immbinStack);
ID = 1;

%Preallocazione
for i = 1:size(immbinStack,3)
    stats = regionprops(immbinStack(:,:,i));
    S(i) = size(stats,1);
end
dummy = cell(sum(S),1);
feats = struct('area',dummy,'perimeter',dummy,'circularity',dummy,'aspectRatio',dummy,'ellipseEccentricity',dummy,'solidity',dummy,'convexity',dummy,'avgGray',dummy,'mask',dummy,'centroid',dummy,'perimPixels',dummy,'BoundingBox',dummy,'Slice',dummy,'Lesion',dummy,'LesionType',dummy,'Name',dummy,'ID',dummy);
stats4 = struct('autoc',dummy,'contr',dummy,'corrm',dummy,'corrp',dummy,'cprom',dummy,'cshad',dummy,'dissi',dummy,'energ',dummy,'entro',dummy,'homom',dummy,'homop',dummy,'maxpr',dummy,'sosvh',dummy,'savgh',dummy,'svarh',dummy,'senth',dummy,'dvarh',dummy,'denth',dummy,'inf1h',dummy,'inf2h',dummy,'indnc',dummy,'idmnc',dummy);
clear dummy;
%% Identificazione delle aree mediante regionprops
for i = 1:size(immbinStack,3)
    stats = regionprops(immbinStack(:,:,i), 'PixelIdxList', 'FilledImage','Area','Centroid','BoundingBox');
    %avgGray = zeros(size(stats,1));
    waitbar(0.33+((i)/size(immbinStack,3))*0.7);    
    for ii=1:size(stats,1)
        mask = false(dim(1),dim(2));
        pixlist = stats(ii).PixelIdxList;
        mask(pixlist) = true;
        [X, Y] = find(bwperim(mask,8));
        avgGray = mean(imst(mask));
        FImageStats = regionprops(stats(ii).FilledImage, 'Area', 'Perimeter', 'MajorAxisLength', 'MinorAxisLength', 'Eccentricity', 'Solidity', 'ConvexImage');
        convexImageStats = regionprops(FImageStats(1).ConvexImage,'Perimeter');
        feats(ID).area = FImageStats(1).Area;
        feats(ID).perimeter = FImageStats(1).Perimeter;       
        feats(ID).circularity = 4*pi*feats(ID).area/feats(ID).perimeter^2;
        feats(ID).aspectRatio = FImageStats(1).MajorAxisLength/FImageStats(1).MinorAxisLength;
        feats(ID).ellipseEccentricity = FImageStats(1).Eccentricity;
        feats(ID).solidity = FImageStats(1).Solidity;
        feats(ID).convexity = convexImageStats(1).Perimeter/feats(ID).perimeter;
        feats(ID).avgGray = avgGray;
        feats(ID).mask = stats(ii).FilledImage;
        feats(ID).centroid = stats(ii).Centroid;
        feats(ID).perimPixels = [X Y];
        feats(ID).BoundingBox = stats(ii).BoundingBox;       
        feats(ID).Slice = i;
        feats(ID).Lesion = false;
        feats(ID).LesionType = 'None';
        feats(ID).Name = strcat('Lesion_',int2str(i),'_',int2str(ii));
        feats(ID).ID = ID;
            
        % SALVO GLI ESTREMI ED EFFETTUO IL CLIPPING
        xs = feats(ID).BoundingBox(2); xf = feats(ID).BoundingBox(2)+feats(ID).BoundingBox(4);
        ys = feats(ID).BoundingBox(1); yf = feats(ID).BoundingBox(1)+feats(ID).BoundingBox(3);
        xs = floor(xs); xf = floor(xf);
        ys = floor(ys); yf = floor(yf);
        if(xs <= 0)
            xs = 1;
        end
        if(ys <= 0)
            ys = 1;
        end
        if(xf > size(immbinStack(:,:,i),1))
            xf = size(immbinStack(:,:,i),1);
        end
        if(yf > size(immbinStack(:,:,i),2))
            yf = size(immbinStack(:,:,i),2);
        end
        % OTTENGO L'IMMAGINE CROPPATA
        imcropped =imst(xs:xf,ys:yf);
        %CALCOLO LA GLCM
        GLCM = graycomatrix(imcropped,'Offset',[2 0;0 2]);
        %CALCOLO LE FEATURES DI HARALICK
        stats4(ID) = GLCM_Features4(GLCM,1);      
        ID = ID+1;   
     end
end
featsFin = struct2table(feats);
stats4Fin = struct2table(stats4);
rp = [featsFin stats4Fin];
rp = table2struct(rp);
close(w);
end
