function rp = get2DlesionsOptirev2(imst)
w = showinfowindow('Estrazione delle lesioni...');
%Dimensioni dello stack di immagini
immbinStack = getBinarizedStackfromImSTrev2(imst);
cellFeats = cell(size(immbinStack,3),1);
cellStats4 = cell(size(immbinStack,3),1);

%% Identificazione delle aree mediante regionprops
for i = 1:size(immbinStack,3)  
    [cellFeats{i}, cellStats4{i}] = getSliceFeat(imst, immbinStack(:,:,i),i);
end
feats = cellFeats{1};
stats4 = cellStats4{1};
for i = 1:size(immbinStack,3)
   feats2 = cellFeats{i};
   stats42 = cellStats4{i};
   feats = [feats; feats2];
   stats4 = [stats4; stats42];
end
feats = struct2table(feats);
stats4 = struct2table(stats4);
ID = uint16(1:size(feats,1))';
IDtable = table(ID);
rp = [feats IDtable stats4];
rp = table2struct(rp);
close(w);
end

function [feats, stats4] = getSliceFeat(imst,binSlice,numSlice)
imm = imst(:,:,numSlice);
stats = regionprops(binSlice, 'PixelIdxList','MajorAxisLength','MinorAxisLength');
dim = size(imm);

clear dummy;
toDelete = false(size(stats,1));
for ii=1:size(stats,1)
    aspectRatio = stats(ii).MajorAxisLength/stats(ii).MinorAxisLength;
    if aspectRatio > 4
        toDelete(ii) = true;
    end
end
stats(toDelete) = [];
dummy = cell(size(stats,1),1);
feats = struct('area',dummy,'perimeter',dummy,'circularity',dummy,'aspectRatio',dummy,'ellipseEccentricity',dummy,'solidity',dummy,'convexity',dummy,'avgGray',dummy,'mask',dummy,'centroid',dummy,'perimPixels',dummy,'BoundingBox',dummy,'Slice',dummy,'Lesion',dummy,'LesionType',dummy,'Name',dummy);
stats4 = struct('autoc',dummy,'contr',dummy,'corrm',dummy,'corrp',dummy,'cprom',dummy,'cshad',dummy,'dissi',dummy,'energ',dummy,'entro',dummy,'homom',dummy,'homop',dummy,'maxpr',dummy,'sosvh',dummy,'savgh',dummy,'svarh',dummy,'senth',dummy,'dvarh',dummy,'denth',dummy,'inf1h',dummy,'inf2h',dummy,'indnc',dummy,'idmnc',dummy);
se = strel('disk',3);
parfor ii=1:size(stats,1)
    mask = false(dim(1),dim(2));
    pixlist = stats(ii).PixelIdxList;
    mask(pixlist) = true;
    %fare active contour o meno
%     dilmask = imdilate(mask,se);
%     diff = dilmask-mask;
%     mediaInterna = mean(imm(find(mask)));
%     mediaEsterna = mean(imm(find(diff)));
%     diffMedie = mediaInterna - mediaEsterna;
%     if diffMedie <= 20
        newmask = activecontour(imm,mask,10); 
        newmask = imfill(newmask,'holes');
%     else    
%         newmask = mask;
%     end    
    stats(ii).mask = newmask;    
    newstats = regionprops(stats(ii).mask, 'PixelIdxList', 'FilledImage','Area','Centroid','BoundingBox');
    mask = false(dim(1),dim(2));
    pixlist = newstats(1).PixelIdxList;
    mask(pixlist) = true; 
    [X, Y] = find(bwperim(mask,8));
    avgGray = mean(imm(mask));
    FImageStats = regionprops(newstats(1).FilledImage, 'Area', 'Perimeter', 'MajorAxisLength', 'MinorAxisLength', 'Eccentricity', 'Solidity', 'ConvexImage');
    convexImageStats = regionprops(FImageStats(1).ConvexImage,'Perimeter');
    feats(ii).area = FImageStats(1).Area;
    feats(ii).perimeter = FImageStats(1).Perimeter;
    feats(ii).circularity = 4*pi*feats(ii).area/feats(ii).perimeter^2;
    feats(ii).aspectRatio = FImageStats(1).MajorAxisLength/FImageStats(1).MinorAxisLength;
    feats(ii).ellipseEccentricity = FImageStats(1).Eccentricity;
    feats(ii).solidity = FImageStats(1).Solidity;
    feats(ii).convexity = convexImageStats(1).Perimeter/feats(ii).perimeter;
    feats(ii).avgGray = avgGray;
    feats(ii).mask = mask;
    feats(ii).centroid = newstats(1).Centroid;
    feats(ii).perimPixels = [X Y];
    feats(ii).BoundingBox = newstats(1).BoundingBox;
    feats(ii).Slice = numSlice;
    feats(ii).Lesion = false;
    feats(ii).LesionType = 'None';
    feats(ii).Name = strcat('Lesion_',int2str(numSlice),'_',int2str(ii));
    
    % SALVO GLI ESTREMI ED EFFETTUO IL CLIPPING
    xs = feats(ii).BoundingBox(2); xf = feats(ii).BoundingBox(2)+feats(ii).BoundingBox(4);
    ys = feats(ii).BoundingBox(1); yf = feats(ii).BoundingBox(1)+feats(ii).BoundingBox(3);
    xs = floor(xs); xf = floor(xf);
    ys = floor(ys); yf = floor(yf);
    if(xs <= 0)
        xs = 1;
    end
    if(ys <= 0)
        ys = 1;
    end
    if(xf > size(binSlice,1))
        xf = size(binSlice,1);
    end
    if(yf > size(binSlice,2))
        yf = size(binSlice,2);
    end
    % OTTENGO L'IMMAGINE CROPPATA
    imcropped =imm(xs:xf,ys:yf);
    %CALCOLO LA GLCM
    GLCM = graycomatrix(imcropped,'Offset',[2 0;0 2]);
    %CALCOLO LE FEATURES DI HARALICK
    stats4(ii) = GLCM_Features4(GLCM,1);
end
end