function rp = get3Dlesions(immbinStack)
warning('off','all');
%Ricerca componenti connesse
conn = bwconncomp(immbinStack,26);
%Restituisci informazioni sulle regioni estratte
rp = regionprops(conn, 'Area', 'PixelIdxList', 'Image','Centroid');
disp('Calculating Isosurfaces...');
%Aggiungi isocaps alle images
for i = 1:size(rp,1)
    di = isosurface(rp(i).Image,0.99);
%     di2 = isocaps(rp(i).Image, 0.99);
    rp(i).surface = di;
%     rp(i).surface.vertices =  [rp(i).surface.vertices; di2.vertices];
%      rp(i).surface.faces =  [rp(i).surface.faces; di2.faces];
end
%Calcola ellissoide che approssima ciascuna lesione
for i = 1:size(rp,1);
    %Calcola centroide
    centr(1) = mean(rp(i).surface.vertices(:,1));
    centr(2) = mean(rp(i).surface.vertices(:,2));
    centr(3) = mean(rp(i).surface.vertices(:,3));
    a = max(rp(i).surface.vertices(:,1)) - min(rp(i).surface.vertices(:,1));
    b = max(rp(i).surface.vertices(:,2)) - min(rp(i).surface.vertices(:,2));
    c = max(rp(i).surface.vertices(:,3)) - min(rp(i).surface.vertices(:,3));
    ma = max(a,b);
    mi = min(a,b);
    rp(i).aspectRatio = single(ma/mi);
    rp(i).name = strcat('Lesion_',int2str(i));
    perbin = zeros(size(immbinStack));
    perbin(rp(i).PixelIdxList) = true;
    perbin = bwperim(perbin,26);
    rp(i).binPerim = perbin;
    clear perbin
    rp(i).Lesion = false;
    rp(i).LesionType = 'None';
    a=a/2;
    b=b/2;
    c=c/2;
    %% Creazione ellissoide
    [X Y Z] = ellipsoid(centr(1),centr(2),centr(3),a,b,c,50);   
    rp(i).ellipsoidSurface = surf2patch(X,Y,Z);
    %% Calcolo distanza di Hausdorff
while size(rp(i).surface.vertices,1) > 2500
    rp(i).surface = reducepatch(rp(i).surface,0.10);
end
[hd, d] = HausdorffDist(rp(i).surface.vertices,rp(i).ellipsoidSurface.vertices,0);
d = min(d,[],2);
%% Calcolo dei punti esterni/interni
    tess = delaunayn(rp(i).ellipsoidSurface.vertices);
    intern = tsearchn(rp(i).ellipsoidSurface.vertices,tess,rp(i).surface.vertices);
    intmask = isnan(intern);
    intmask2 = double(intmask);
    intmask2(intmask==0)= -1;
    d = d.*intmask2;
    
%% Calcolo Features3D
rp(i).maxPeakValue = max(d);
rp(i).maxValleyValue = abs(min(d));
rp(i).rootMeanSquaredError = rms(d);
rp(i).absAvg = mean(abs(d));
rp(i).skewness = skewness(d);
rp(i).kurtosis = kurtosis(d);
clear intern d intmask intmask2 tess
end
%RIMUOVERE ZONE CON ASPECT RATIO ALTO
% ditot = isosurface(immbinStack,0.99);
% patch(ditot);
end