function [immbinStack] = getBinarizedStack(DCMName)
dicomImm = dicomread(DCMName);
dicomInf = dicominfo(DCMName);
dI = dicomInf.PerFrameFunctionalGroupsSequence;
dI = struct2table(dI);
clear dicomInf;
numFrames = size(dicomImm,4);
clc;
disp('Reading Images and binarizing...');
immbinStack = zeros(uint16(single(size(dicomImm,1))/2),uint16(single(size(dicomImm,2))/2),size(dicomImm,4));
for fr=1:numFrames
 %% Binarizzazione immagine
    imm = dicomImm(:,:,1,fr);
    WW = dI{1,fr}.FrameVOILUTSequence.Item_1.WindowWidth(1);
    WC =dI{1,fr}.FrameVOILUTSequence.Item_1.WindowCenter(1);
    imm = adjustImm(imm, WW, WC, 0, 255); 
    imm = imm(1:2:end,1:2:end);
    imm = medfilt2(imm);
    thr = prctile(imm(imm>1),90);
    immbinStack(:,:,fr) = imm >= thr;    
end
disp('Filling Gaps and holes...');
%Filling Gaps e holes
clearvars -except immbinStack;
immbinStack = logical(immbinStack);

immbinStack = imclose(immbinStack, strel('disk',5));
for i=1:size(immbinStack,3)
    immbinStack(:,:,i) = imfill(immbinStack(:,:,i),'holes');
end
immbinStack = imfill(immbinStack,26,'holes');

%Erosione e dilatazione
disp('Erosion...');
immbinStack = imerode(immbinStack, strel('sphere',2));
immbinStack = imerode(immbinStack, strel('sphere',1));
immbinStack = imerode(immbinStack, strel('sphere',1));

disp('Removing small regions...');
immbinStack = bwareaopen(immbinStack,70,8);

disp('Dilation...');
immbinStack = imdilate(immbinStack,strel('sphere',2));
immbinStack = imdilate(immbinStack,strel('sphere',1));
immbinStack = imdilate(immbinStack,strel('sphere',1));
end
