function [immbinStack] = getBinarizedStackfromImST(dicomImm)
numFrames = size(dicomImm,3);
clc;
immbinStack = false(size(dicomImm));
dicomImm = removeBorders(dicomImm);
parfor fr=1:numFrames
 %% Binarizzazione immagine
    imm = dicomImm(:,:,fr);
    imm = medfilt2(imm);
    %imm = imadjust(imm,[],[],3);
    temp = imm(imm>1);
    if ~isempty(temp)
    thr = prctile(imm(imm>1),95);
    immbinStack(:,:,fr) = imm >= thr; 
    end
end
disp('Filling Gaps and holes...');
%Filling Gaps e holes
clearvars -except immbinStack;
immbinStack = logical(immbinStack);

%immbinStack = imclose(immbinStack, strel('disk',5));
for i=1:size(immbinStack,3)
    immbinStack(:,:,i) = imfill(immbinStack(:,:,i),'holes');
end
immbinStack = imfill(immbinStack,26,'holes');

%Erosione e dilatazione
disp('Erosion...');
immbinStack = imerode(immbinStack, strel('sphere',2));
immbinStack = imerode(immbinStack, strel('sphere',1));
immbinStack = imerode(immbinStack, strel('sphere',1));

disp('Removing small regions...');
immbinStack = bwareaopen(immbinStack,70,8);

disp('Dilation...');
immbinStack = imdilate(immbinStack,strel('sphere',2));
immbinStack = imdilate(immbinStack,strel('sphere',1));
immbinStack = imdilate(immbinStack,strel('sphere',1));
end
