function [immbinStack] = getBinarizedStackfromImSTGPU(dicomImm,gpu)
numFrames = size(dicomImm,3);
clc;
immbinStack = zeros(size(dicomImm),'logical','gpuArray');
for fr=1:numFrames
 %% Binarizzazione immagine
    imm = dicomImm(:,:,fr);
    imm = medfilt2(imm);
    imm = imadjust(imm,[],[],3);
    thr = prctile(imm(imm>1),90);
    immbinStack(:,:,fr) = imm >= thr;    
end
disp('Filling Gaps and holes...');
%Filling Gaps e holes
clearvars -except immbinStack gpu;

%immbinStack = imclose(immbinStack, strel('disk',5));
for i=1:size(immbinStack,3)
    immbinStack(:,:,i) = imfill(immbinStack(:,:,i),'holes');
end

%Erosione e dilatazione
for j =1:size(immbinStack,3)
immbinStack(:,:,j) = imerode(immbinStack(:,:,j), strel('disk',2));
immbinStack(:,:,j) = imerode(immbinStack(:,:,j), strel('disk',1));
immbinStack(:,:,j) = imerode(immbinStack(:,:,j), strel('disk',1));

immbinStack = gather(immbinStack);
immbinStack(:,:,j) = bwareaopen(immbinStack(:,:,j),70,8);
immbinStack = gpuArray(immbinStack);

immbinStack(:,:,j) = imdilate(immbinStack(:,:,j),strel('disk',2));
immbinStack(:,:,j) = imdilate(immbinStack(:,:,j),strel('disk',1));
immbinStack(:,:,j) = imdilate(immbinStack(:,:,j),strel('disk',1));
end
wait(gpu);
end